'use strict';

var ReactInjection = require('react/lib/ReactInjection');
var JSONEventListener = require('./json-event-listener');
var DefaultEventPluginOrder = require('./default-event-plugin-order');
var ReactInstanceHandles = require('react/lib/ReactInstanceHandles');
var JSONMount = require('./json-mount');
var JSONComponent = require('./json-component');
var JSONTextComponent = require('./json-text-component');
var JSONComponentMixin = require('./json-component-mixin');
var HTMLDOMPropertyConfig = require('react/lib/HTMLDOMPropertyConfig');
var SVGDOMPropertyConfig = require('react/lib/SVGDOMPropertyConfig');
var JSONReconcileTransaction = require('./json-reconcile-transaction');
var ReactDefaultBatchingStrategy = require('react/lib//ReactDefaultBatchingStrategy');
var ClientReactRootIndex = require('react/lib/ClientReactRootIndex');
var JSONComponentEnvironment = require('./json-component-environment');

module.exports = function () {
  ReactInjection.EventEmitter.injectReactEventListener(JSONEventListener);

  ReactInjection.EventPluginHub.injectEventPluginOrder(DefaultEventPluginOrder);
  ReactInjection.EventPluginHub.injectInstanceHandle(ReactInstanceHandles);
  ReactInjection.EventPluginHub.injectMount(JSONMount);

  ReactInjection.NativeComponent.injectGenericComponentClass(JSONComponent);
  ReactInjection.NativeComponent.injectTextComponentClass(JSONTextComponent);

  ReactInjection.Class.injectMixin(JSONComponentMixin);

  ReactInjection.DOMProperty.injectDOMPropertyConfig(HTMLDOMPropertyConfig);
  ReactInjection.DOMProperty.injectDOMPropertyConfig(SVGDOMPropertyConfig);

  ReactInjection.EmptyComponent.injectEmptyComponent('noscript');

  ReactInjection.Updates.injectReconcileTransaction(JSONReconcileTransaction);
  ReactInjection.Updates.injectBatchingStrategy(ReactDefaultBatchingStrategy);

  ReactInjection.RootIndex.injectCreateReactRootIndex(ClientReactRootIndex.createReactRootIndex);

  ReactInjection.Component.injectEnvironment(JSONComponentEnvironment);
};